// Generated by LiveScript 1.6.0
(function(){
  var Cluster, mkdirp, path, extract, importCwd, puppeteer, getText, reqHandle, getTextTask, collect, extractor, out$ = typeof exports != 'undefined' && exports || this;
  Cluster = require('puppeteer-cluster').Cluster;
  mkdirp = require('mkdirp');
  path = require('path');
  extract = require('./util').extract;
  importCwd = require('import-cwd');
  puppeteer = importCwd('puppeteer');
  getText = async function(page, url, fontName, scrollElementSelector, timeWait){
    var handle, text;
    (await page.goto(url, {
      waitUntil: 'networkidle2'
    }));
    if (scrollElementSelector) {
      try {
        (await page.$eval(scrollElementSelector, function(e){
          do {
            e.scrollBy(0, e.scrollHeight, {
              behavior: 'auto'
            });
          } while (e.scrollHeight - e.scrollTop !== e.offsetHeight);
        }));
      } catch (e$) {}
    }
    handle = new Function("eles", "return eles.filter((e)=> window.getComputedStyle(e).getPropertyValue(\"font-family\")\n.split(\",\").map( (x) => x.trim() )\n.includes('" + fontName + "'))\n.reduce( ( (p,c)=> p+= c.textContent ),\"\" )\n.split(\"\")\n.filter( (v,i,s)=> s.indexOf(v) === i )");
    if (scrollElementSelector) {
      (await page.waitFor(timeWait));
      try {
        (await page.waitFor(function(e){
          return e.scrollHeight - e.scrollTop === e.offsetHeight;
        }, scrollElementSelector));
      } catch (e$) {}
    }
    text = (await page.$$eval("*", handle));
    return text;
  };
  reqHandle = function(req){
    if (req.resourceType() === 'image' || req.resourceType() === 'font') {
      return req.abort();
    } else {
      return req['continue']();
    }
  };
  getTextTask = async function(arg$){
    var page, data;
    page = arg$.page, data = arg$.data;
    (await page.setRequestInterception(true));
    page.setDefaultTimeout(6000);
    page.on('request', reqHandle);
    return (await getText(page, data.url, data.fontName, data.scrollElementSelector, data.timeWait));
  };
  out$.collect = collect = async function(entry, fontName, scrollElement, timeWait){
    var cluster, text, hrefs, entryURL, entryNom, visited, pages, filtered, i$, len$, href, url, e, urlS, pp, p, tt, t;
    cluster = (await Cluster.launch({
      puppeteer: puppeteer,
      concurrency: Cluster.CONCURRENCY_CONTEXT
    }, {
      maxConcurrency: 4,
      puppeteerOptions: {
        args: ['--no-sandbox', '--disable-setuid-sandbox']
      }
    }));
    (await cluster.task(getTextTask));
    text = (await cluster.execute({
      url: entry,
      fontName: fontName,
      scrollElementSelector: scrollElement,
      timeWait: timeWait
    }));
    hrefs = (await cluster.execute(entry, async function(arg$){
      var page, url;
      page = arg$.page, url = arg$.data;
      (await page.setRequestInterception(true));
      page.on('request', reqHandle);
      (await page.goto(url, {
        waitUntil: 'networkidle2'
      }));
      return (await page.$$eval("a", function(l){
        return l.map(function(v){
          return v.href;
        });
      }));
    }));
    entryURL = new URL(entry);
    entryNom = entryURL.toString();
    visited = [entryNom];
    pages = [];
    filtered = hrefs.filter(function(x){
      return x.startsWith("http");
    });
    for (i$ = 0, len$ = filtered.length; i$ < len$; ++i$) {
      href = filtered[i$];
      url = "";
      try {
        url = new URL(href);
      } catch (e$) {
        e = e$;
        continue;
      }
      urlS = url.toString();
      if (visited.indexOf(urlS) === -1 && url.origin === entryURL.origin) {
        pages.push(urlS);
      }
    }
    pp = [];
    while (p = pages.shift()) {
      pp.push(cluster.execute({
        url: p,
        fontName: fontName,
        scrollElementSelector: scrollElement,
        timeWait: timeWait
      }));
      visited.push(p);
    }
    tt = (await Promise.all(pp));
    for (i$ = 0, len$ = tt.length; i$ < len$; ++i$) {
      t = tt[i$];
      text = text.concat(t);
    }
    text = text.filter(function(v, i, s){
      return deepEq$(s.indexOf(v), i, '===');
    });
    (await cluster.idle());
    (await cluster.close());
    return text;
  };
  out$.extractor = extractor = async function(config){
    var textArray, words, transFont;
    textArray = (await collect(config.entry, config.fname, config.ss, config.sw));
    words = config.preserved.concat(textArray);
    consol.log("collected size:" + textArray.length + "\n " + textArray);
    transFont = extract(config, words);
    mkdirp.sync(path.dirname(config.output));
    return transFont.output({
      path: config.output
    });
  };
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
