// Generated by LiveScript 1.6.0
(function(){
  var fs, iconv, glob, mkdirp, path, extract, util, performance, readFile, readText, getAllText, extractor, toString$ = {}.toString, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  iconv = require('iconv-lite');
  glob = require('fast-glob');
  mkdirp = require('mkdirp');
  path = require('path');
  extract = require('./util').extract;
  util = require('util');
  performance = require('perf_hooks').performance;
  readFile = util.promisify(fs.readFile);
  readText = async function(file, encoding){
    var _encoding, bin, content;
    encoding == null && (encoding = "utf-8");
    _encoding = encoding.toLowerCase();
    bin = (await readFile(file));
    if (_encoding === "utf-8") {
      if (bin[0] === 0xEF && bin[1] === 0xBB && bin[2] === 0xBF) {
        bin = bin.slice(3);
      }
      content = bin.toString("utf-8");
    } else if (_encoding === "gbk") {
      content = iconv.decode(bin, "gbk");
    }
    return content.split("").filter(function(value, index, self){
      return self.indexOf(value) === index && /[\u4e00-\u9fa5]/.exec(value);
    });
  };
  getAllText = async function(config){
    var options, reduceFile, files;
    options = {
      nodir: true,
      matchBase: true,
      ignore: ["**/*.ttf", "**/*.woff", "**/*.woff2", "**/*.eot", "**/*.svg"]
    };
    reduceFile = async function(p, c, i){
      var prev;
      prev = (await p);
      return prev.concat((await readText(c, config.encoding)));
    };
    if (toString$.call(config.source).slice(8, -1) === "String") {
      files = (await glob(config.source, options));
      return files.reduce(reduceFile, Promise.resolve([]));
    } else if (toString$.call(config.source).slice(8, -1) === "Object") {
      if (toString$.call(config.source.ignore).slice(8, -1) === "Array") {
        options.ignore.concat(config.source.ignore);
      }
      files = (await glob(config.source.path, options));
      return files.reduce(reduceFile, Promise.resolve([]));
    }
  };
  out$.extractor = extractor = async function(config){
    var start, textArray, words, transFont, dur, glyph;
    start = performance.now();
    textArray = (await getAllText(config));
    words = config.preserved.concat(textArray);
    transFont = extract(config, words);
    mkdirp.sync(path.dirname(config.output));
    transFont.output({
      path: config.output
    });
    dur = performance.now() - start;
    glyph = Object.keys(transFont.allGlyph()).length;
    return console.log("glyph size:" + glyph + " collected size:" + textArray.length + "\n " + textArray + " \nextraction takes:" + dur + " milliseconds.");
  };
}).call(this);
